SHOW_NDX Function

FUNCTION show_ndx
PRIVATE i, j, k, m_name, wcount

***  function displays indexes on open data table

IF .not. isblank(alias())     &&  we have a dbf

  DEFINE WINDOW w_index FROM 02,08 ;
                        TO 22,71 DOUBLE
  ACTIVATE WINDOW w_index

  IF isblank(tag(1))          &&  nothing there!
    @ 02,20 SAY 'No active indexes of any kind '
    @ 03,20 SAY 'on this data table.'
    @ 04,20 SAY '..... Press any key to continue'
    junk = inkey(0)
  ELSE
    STORE 1 TO i, j, k, wcount

    DO WHILE i <= tagcount()

      IF .not. isblank(ndx(i)) &&  active NDX
        ??  ' .NDX FILES'
        DO ndx_head
      ENDIF

      DO WHILE .not. isblank(ndx(i)) .and. ;
                     i <= tagcount()
        DO ndx_body
      ENDDO

      IF .not. isblank(mdx(j))  && mdx file exists
        m_name = mdx(j)

        IF wcount > 13
          ?
          WAIT
          CLEAR
        ENDIF

        IF substr(m_name,1,at('.',m_name)) =;
           substr(dbf(),1,at('.',dbf()))
          ?
          ?  ' STRUCTURAL MASTER INDEX FILE'
        ELSE
          ?
          ?  ' SECONDARY MASTER INDEX FILE'
        ENDIF

        DO ndx_head
      ENDIF

      DO WHILE .not. isblank(tag(m_name,k)) ;
               .and. i <= tagcount()
        DO ndx_body
        k = k + 1
      ENDDO

      k = 1
      j = j + 1    &&  increment mdx name

      IF wcount >= 13

        IF i <= tagcount()
          WAIT
          CLEAR
          wcount = 1
        ENDIF
      ENDIF
    ENDDO
  ENDIF

  ?
  WAIT 
  CLEAR
  RELEASE WINDOW w_index 
ENDIF

RETURN(tagcount())

********

PROCEDURE ndx_head

?  ' Order  Name   For Unq Dir    Key'
?  ' ----- -------- -- -- -- --------------------'+;
   '---------'
wcount = wcount + 3

RETURN

*******

PROCEDURE ndx_body

IF wcount >= 19
  ?
  WAIT 
  CLEAR
  wcount = 1
ENDIF

? ltrim(str(i)) PICTURE '99' AT 01

IF .not. isblank(order()) .and. tag(i) = order()
  ?? ' **'
ENDIF

?? tag(i) AT 07
?? iif(isblank(for(i)), '', chr(251)) AT 17
?? iif(unique(i), chr(251), '')  AT 19
?? iif(descending(i), chr(25), chr(24)) AT 22

IF len(key(i)) < 39
  ?? key(i) AT 24
ELSE
  ?? substr(key(i),1,33) + '....' AT 24
ENDIF

wcount = wcount + 1
i = i + 1

RETURN

********


