/* Include the C I/O function header and the Clipper
     Extend System header */

 #include <stdio.h>
 #include <extend.h>

 static char ow[256];	/* working array */

 CLIPPER ctoan(void)
 {
 int pb;               /* possible blanks       */
 register int lpb;     /* local possible blanks */
 int numc;             /* numerics to copy      */
 register int i;       /* working variable      */
 char *owx;            /* output index          */
 char *spx;            /* input index           */
 register char *ix;    /* working index         */
 char *wlx;            /* end of word index     */

/* Retrieve the string we want to format from Clipper. */

 spx=_parc(1);
 lpb=_parclen(1);

 wlx=spx+lpb;	/* Determine the ending address of the string in memory. */
 pb =lpb+1;	/* Store the string length for looping. */
 owx=&ow[0];	/* Get the address of the first working array element. */

/* Keep performing this loop until we run out of string to
     process */

 while (pb > 0)
   {
  while (spx < wlx)                        /* Copy Alpha */
    {
     if (*spx>='0' && *spx<='9') break;
     *owx++=*spx++;
     lpb--;
     }
   numc=0;
   for (ix=spx;ix<wlx;ix++)                 /* Count numerics */
     {
     if (!(*ix>='0' && *ix<='9')) break;
     lpb--;
     numc++;
     }
   for (i=1;i<=lpb;i++)   *owx++=' ';       /* Fill Blanks */
   for (i=1;i<=numc;i++)  *owx++=*spx++;    /* Copy numerics */
   pb -= 2;
   lpb = pb;
   };
 *owx++='\0';
 _retc(ow);
 }


